Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -956,177 +1373,1159 @@
 #endif
     vmea(:)%ns_soil_tot = ns_all(:)
-    
+
     DEALLOCATE( ns_all )
-!                               
-!-- Dellocate flag array
-    DEALLOCATE( meas_flag )
-!
-!-- Initialize binary data output of virtual measurements.
-!-- Open binary output file.
-    CALL check_open( 27 )
-!
-!-- Output header information.
-    CALL vm_data_output
-        
+!
+!-- In case of parallel NetCDF the start coordinate for each mpi rank needs to
+!-- be defined, so that each processor knows where to write the data.
+#if defined( __netcdf4_parallel )
+    ALLOCATE( ns_atmos(0:numprocs-1,1:vmea_general%nvm) )
+    ALLOCATE( ns_soil(0:numprocs-1,1:vmea_general%nvm)  )
+    ns_atmos = 0
+    ns_soil  = 0
+
+    DO  l = 1, vmea_general%nvm
+       ns_atmos(myid,l) = vmea(l)%ns
+       ns_soil(myid,l)  = vmea(l)%ns_soil
+    ENDDO
+
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_atmos, numprocs * vmea_general%nvm,   &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
+    CALL MPI_ALLREDUCE( MPI_IN_PLACE, ns_soil, numprocs * vmea_general%nvm,    &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
+#else
+    ns_atmos(0,:) = vmea(:)%ns
+    ns_soil(0,:)  = vmea(:)%ns_soil
+#endif
+
+!
+!-- Determine the start coordinate in NetCDF file for the local arrays.
+!-- Note, start coordinates are initialized with zero for sake of simplicity
+!-- in summation. However, in NetCDF the start coordinates must be >= 1,
+!-- so that a one needs to be added at the end. 
+    DO  l = 1, vmea_general%nvm
+       DO  n  = 0, myid - 1
+          vmea(l)%start_coord_a = vmea(l)%start_coord_a + ns_atmos(n,l)
+          vmea(l)%start_coord_s = vmea(l)%start_coord_s + ns_soil(n,l)
+       ENDDO
+!
+!--    Start coordinate in NetCDF starts always at one not at 0.
+       vmea(l)%start_coord_a = vmea(l)%start_coord_a + 1
+       vmea(l)%start_coord_s = vmea(l)%start_coord_s + 1
+!
+!--    Determine the local end coordinate
+       vmea(l)%end_coord_a = vmea(l)%start_coord_a + vmea(l)%ns - 1
+       vmea(l)%end_coord_s = vmea(l)%start_coord_s + vmea(l)%ns_soil - 1
+    ENDDO
+
+    DEALLOCATE( ns_atmos )
+    DEALLOCATE( ns_soil  )
+
+#endif
+
+#endif
+
   END SUBROUTINE vm_init
-  
-  
+
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Binary data output.
+!> Initialize output using data-output module
 !------------------------------------------------------------------------------!
-  SUBROUTINE vm_data_output
-    
-     USE pegrid
-    
-     IMPLICIT NONE
-         
-     INTEGER(iwp) ::  i  !< running index over IO blocks    
-     INTEGER(iwp) ::  l  !< running index over all stations
-     INTEGER(iwp) ::  n  !< running index over all measured variables at a station
-!
-!--  Header output on each PE
-     IF ( init )  THEN
-
-        DO  i = 0, io_blocks-1
-           IF ( i == io_group )  THEN
-              WRITE ( 27 )  'number of measurements            '
-              WRITE ( 27 )  vmea_general%nvm
-
-              DO  l = 1, vmea_general%nvm
-                 WRITE ( 27 )  'site                              '
-                 WRITE ( 27 )  vmea(l)%site
-                 WRITE ( 27 )  'file                              '
-                 WRITE ( 27 )  vmea(l)%filename_original
-                 WRITE ( 27 )  'feature_type                      '
-                 WRITE ( 27 )  vmea(l)%feature_type
-                 WRITE ( 27 )  'origin_x_obs                      '
-                 WRITE ( 27 )  vmea(l)%origin_x_obs
-                 WRITE ( 27 )  'origin_y_obs                      '
-                 WRITE ( 27 )  vmea(l)%origin_y_obs
-                 WRITE ( 27 )  'total number of observation points'                               
-                 WRITE ( 27 )  vmea(l)%ns_tot
-                 WRITE ( 27 )  'number of measured variables      '
-                 WRITE ( 27 )  vmea(l)%nmeas
-                 WRITE ( 27 )  'variables                         '
-                 WRITE ( 27 )  vmea(l)%measured_vars_name(:)
-                 WRITE ( 27 )  'number of observation points      '
-                 WRITE ( 27 )  vmea(l)%ns
-                 WRITE ( 27 )  'E_UTM                             '
-                 WRITE ( 27 )  init_model%origin_x                             &
+ SUBROUTINE vm_init_output
+
+    CHARACTER(LEN=100) ::  variable_name  !< name of output variable
+
+    INTEGER(iwp) ::  l              !< loop index
+    INTEGER(iwp) ::  n              !< loop index
+    INTEGER      ::  return_value   !< returned status value of called function
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ndim !< dummy to write dimension
+
+    REAL(wp) ::  dum_lat !< transformed geographical coordinate (latitude)
+    REAL(wp) ::  dum_lon !< transformed geographical coordinate (longitude)
+
+!
+!-- Determine the number of output timesteps. Set a maximum value of 80000
+!-- timesteps.
+    ntimesteps = MIN( CEILING(                                                 &
+                  ( end_time - MAX( vm_time_start, time_since_reference_point )&
+                  ) / MAX( 0.1_wp, dt_virtual_measurement ) ), ntimesteps_max )
+!
+!-- Create directory where output files will be stored.
+    CALL local_system( 'mkdir -p VM_OUTPUT' // TRIM( coupling_char ) )
+!
+!-- Loop over all sites.
+    DO  l = 1, vmea_general%nvm
+!
+!--    Skip if no observations will be taken for this site.
+       IF ( vmea(l)%ns_tot == 0  .AND.  vmea(l)%ns_soil_tot == 0 )  CYCLE
+!
+!--    Define output file.
+       WRITE( vmea(l)%nc_filename, '(A,I4.4)')  'VM_OUTPUT' //                 &
+                                                TRIM( coupling_char ) // '/' //&
+                                                'site', l
+
+
+       return_value = dom_def_file( vmea(l)%nc_filename, 'netcdf4-parallel' )
+!
+!--    Define global attributes.
+!--    Before, transform UTM into geographical coordinates.
+       CALL convert_utm_to_geographic( crs_list,                               &
+                                       vmea(l)%origin_x_obs,                   &
+                                       vmea(l)%origin_y_obs,                   &
+                                       dum_lon,                                &
+                                       dum_lat )
+
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'site',                    &
+                                   value = TRIM( vmea(l)%site ) )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'title',                   &
+                                   value = 'Virtual measurement output')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'source',                  &
+                                   value = 'PALM-4U')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'institution',             &
+                                   value = input_file_atts%institution )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'acronym',                 &
+                                   value = input_file_atts%acronym )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'author',                  &
+                                   value = input_file_atts%author )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'contact_person',          &
+                                   value = input_file_atts%contact_person )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'iop',                     &
+                                   value = input_file_atts%campaign )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'campaign',                &
+                                   value = 'PALM-4U' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_time ',            &
+                                   value = origin_date_time)
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'location',                &
+                                   value = input_file_atts%location )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_x',                &
+                                   value = vmea(l)%origin_x_obs )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_y',                &
+                                   value = vmea(l)%origin_y_obs )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_lon',              &
+                                   value = dum_lon )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_lat',              &
+                                   value = dum_lat )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'origin_z',                &
+                                   value = 0.0 )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'rotation_angle',          &
+                                   value = input_file_atts%rotation_angle )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'featureType',             &
+                                   value = TRIM( vmea(l)%feature_type_out ) )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'data_content',            &
+                                   value = TRIM( vmea(l)%data_content ) )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'creation_time',           &
+                                   value = input_file_atts%creation_time )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'version',                 &
+                                   value = 1 ) !input_file_atts%version )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'creation_time',           &
+                                   value = TRIM( vmea(l)%site ) )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'Conventions',             &
+                                   value = input_file_atts%conventions )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'dependencies',            &
+                                   value = input_file_atts%dependencies )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'history',                 &
+                                   value = input_file_atts%history )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'references',              &
+                                   value = input_file_atts%references )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'comment',                 &
+                                   value = input_file_atts%comment )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'keywords',                &
+                                   value = input_file_atts%keywords )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   attribute_name = 'licence',                 &
+                                   value = '[UC]2 Open Licence; see [UC]2 ' // &
+                                           'data policy available at ' //      &
+                                           'www.uc2-program.org/uc2_data_policy.pdf' )
+!
+!--    Define dimensions.
+!--    station
+       ALLOCATE( ndim(1:vmea(l)%ns_tot) )
+       DO  n = 1, vmea(l)%ns_tot
+          ndim(n) = n
+       ENDDO
+       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
+                                   dimension_name = 'station',                 &
+                                   output_type = 'int32',                      &
+                                   bounds = (/1_iwp, vmea(l)%ns_tot/),         &
+                                   values_int32 = ndim )
+       DEALLOCATE( ndim )
+!
+!--    ntime
+       ALLOCATE( ndim(1:ntimesteps) )
+       DO  n = 1, ntimesteps
+          ndim(n) = n
+       ENDDO
+
+       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
+                                   dimension_name = 'ntime',                   &
+                                   output_type = 'int32',                      &
+                                   bounds = (/1_iwp, ntimesteps/),             &
+                                   values_int32 = ndim )
+       DEALLOCATE( ndim )
+!
+!--    nv
+       ALLOCATE( ndim(1:2) )
+       DO  n = 1, 2
+          ndim(n) = n
+       ENDDO
+
+       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
+                                   dimension_name = 'nv',                      &
+                                   output_type = 'int32',                      &
+                                   bounds = (/1_iwp, 2_iwp/),                  &
+                                   values_int32 = ndim )
+       DEALLOCATE( ndim )
+!
+!--    maximum name length
+       ALLOCATE( ndim(1:maximum_name_length) )
+       DO  n = 1, maximum_name_length
+          ndim(n) = n
+       ENDDO
+
+       return_value = dom_def_dim( vmea(l)%nc_filename,                        &
+                                   dimension_name = 'max_name_len',            &
+                                   output_type = 'int32',                      &
+                                   bounds = (/1_iwp, 32_iwp/),                 &
+                                   values_int32 = ndim )
+       DEALLOCATE( ndim )
+!
+!--    Define coordinate variables.
+!--    time
+       variable_name = 'time'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/ 'station  ',           &
+                                                        'ntime    '/),         &
+                                   output_type = 'real32' )
+!
+!--    station_name. DOM needs to be enabled to define CHARACTER variables.
+!        variable_name = 'station_name'
+!        return_value = dom_def_var( vmea(l)%nc_filename,                        &
+!                                    variable_name = variable_name,              &
+!                                    dimension_names = (/ 'max_name_len',        &
+!                                                         'station     '/),      &
+!                                    output_type = 'char' )
+!
+!--    vrs (vertical reference system)
+       variable_name = 'vrs'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/ 'station' /),          &
+                                   output_type = 'int8' )
+!
+!--    crs (coordinate reference system)
+       variable_name = 'crs'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/ 'station' /),          &
+                                   output_type = 'int8' )
+!
+!--    z
+       variable_name = 'z'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    station_h
+       variable_name = 'station_h'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    x
+       variable_name = 'x'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    y
+       variable_name = 'y'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    E-UTM
+       variable_name = 'E_UTM'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    N-UTM
+       variable_name = 'N_UTM'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    latitude
+       variable_name = 'lat'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    longitude
+       variable_name = 'lon'
+       return_value = dom_def_var( vmea(l)%nc_filename,                        &
+                                   variable_name = variable_name,              &
+                                   dimension_names = (/'station'/),            &
+                                   output_type = 'real32' )
+!
+!--    Set attributes for the coordinate variables. Note, not all coordinates
+!--    have the same number of attributes.
+!--    Units
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = char_unit,                 &
+                                   value = 'seconds since ' // origin_date_time )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'z',                        &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_h',                &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'x',                        &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'y',                        &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'E_UTM',                    &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'N_UTM',                    &
+                                   attribute_name = char_unit,                 &
+                                   value = 'm' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lat',                      &
+                                   attribute_name = char_unit,                 &
+                                   value = 'degrees_north' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lon',                      &
+                                   attribute_name = char_unit,                 &
+                                   value = 'degrees_east' )
+!
+!--    Long name
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_name',             &
+                                   attribute_name = char_long,                 &
+                                   value = 'station name')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = char_long,                 &
+                                   value = 'time')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'z',                        &
+                                   attribute_name = char_long,                 &
+                                   value = 'height above origin' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_h',                &
+                                   attribute_name = char_long,                 &
+                                   value = 'surface altitude' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'x',                        &
+                                   attribute_name = char_long,                 &
+                                   value = 'distance to origin in x-direction' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'y',                        &
+                                   attribute_name = char_long,                 &
+                                   value = 'distance to origin in y-direction' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'E_UTM',                    &
+                                   attribute_name = char_long,                 &
+                                   value = 'easting' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'N_UTM',                    &
+                                   attribute_name = char_long,                 &
+                                   value = 'northing' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lat',                      &
+                                   attribute_name = char_long,                 &
+                                   value = 'latitude' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lon',                      &
+                                   attribute_name = char_long,                 &
+                                   value = 'longitude' )
+!
+!--    Standard name
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_name',             &
+                                   attribute_name = char_standard,             &
+                                   value = 'platform_name')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = char_standard,             &
+                                   value = 'time')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'z',                        &
+                                   attribute_name = char_standard,             &
+                                   value = 'height_above_mean_sea_level' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_h',                &
+                                   attribute_name = char_standard,             &
+                                   value = 'surface_altitude' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'E_UTM',                    &
+                                   attribute_name = char_standard,             &
+                                   value = 'projection_x_coordinate' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'N_UTM',                    &
+                                   attribute_name = char_standard,             &
+                                   value = 'projection_y_coordinate' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lat',                      &
+                                   attribute_name = char_standard,             &
+                                   value = 'latitude' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'lon',                      &
+                                   attribute_name = char_standard,             &
+                                   value = 'longitude' )
+!
+!--    Axis
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = 'axis',                    &
+                                   value = 'T')
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'z',                        &
+                                   attribute_name = 'axis',                    &
+                                   value = 'Z' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'x',                        &
+                                   attribute_name = 'axis',                    &
+                                   value = 'X' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'y',                        &
+                                   attribute_name = 'axis',                    &
+                                   value = 'Y' )
+!
+!--    Set further individual attributes for the coordinate variables.
+!--    For station name
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'station_name',             &
+                                   attribute_name = 'cf_role',                 &
+                                   value = 'timeseries_id' )
+!
+!--    For time
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = 'calendar',                &
+                                   value = 'proleptic_gregorian' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'time',                     &
+                                   attribute_name = 'bounds',                  &
+                                   value = 'time_bounds' )
+!
+!--    For vertical reference system
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'vrs',                      &
+                                   attribute_name = char_long,                 &
+                                   value = 'vertical reference system' )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'vrs',                      &
+                                   attribute_name = 'system_name',             &
+                                   value = 'DHHN2016' )
+!
+!--    For z
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'z',                        &
+                                   attribute_name = 'positive',                &
+                                   value = 'up' )
+!
+!--    For coordinate reference system
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'epsg_code',               &
+                                   value = coord_ref_sys%epsg_code )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'false_easting',           &
+                                   value = coord_ref_sys%false_easting )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'false_northing',          &
+                                   value = coord_ref_sys%false_northing )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'grid_mapping_name',       &
+                                   value = coord_ref_sys%grid_mapping_name )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'inverse_flattening',      &
+                                   value = coord_ref_sys%inverse_flattening )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'latitude_of_projection_origin',&
+                                   value = coord_ref_sys%latitude_of_projection_origin )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = char_long,                 &
+                                   value = coord_ref_sys%long_name )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'longitude_of_central_meridian', &
+                                   value = coord_ref_sys%longitude_of_central_meridian )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'longitude_of_prime_meridian', &
+                                   value = coord_ref_sys%longitude_of_prime_meridian )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'scale_factor_at_central_meridian', &
+                                   value = coord_ref_sys%scale_factor_at_central_meridian )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = 'semi_major_axis',         &
+                                   value = coord_ref_sys%semi_major_axis )
+       return_value = dom_def_att( vmea(l)%nc_filename,                        &
+                                   variable_name = 'crs',                      &
+                                   attribute_name = char_unit,                 &
+                                   value = coord_ref_sys%units )
+!
+!--    In case of sampled soil quantities, define further dimensions and
+!--    coordinates.
+       IF ( vmea(l)%soil_sampling )  THEN
+!
+!--       station for soil
+          ALLOCATE( ndim(1:vmea(l)%ns_soil_tot) )
+          DO  n = 1, vmea(l)%ns_soil_tot
+             ndim(n) = n
+          ENDDO
+
+          return_value = dom_def_dim( vmea(l)%nc_filename,                     &
+                                      dimension_name = 'station_soil',         &
+                                      output_type = 'int32',                   &
+                                      bounds = (/1_iwp,vmea(l)%ns_soil_tot/),  &
+                                      values_int32 = ndim )
+          DEALLOCATE( ndim )
+!
+!--       ntime for soil
+          ALLOCATE( ndim(1:ntimesteps) )
+          DO  n = 1, ntimesteps
+             ndim(n) = n
+          ENDDO
+
+          return_value = dom_def_dim( vmea(l)%nc_filename,                     &
+                                      dimension_name = 'ntime_soil',           &
+                                      output_type = 'int32',                   &
+                                      bounds = (/1_iwp,ntimesteps/),           &
+                                      values_int32 = ndim )
+          DEALLOCATE( ndim )
+!
+!--       time for soil
+          variable_name = 'time_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil',      &
+                                                          'ntime_soil  '/),    &
+                                      output_type = 'real32' )
+!
+!--       station_name for soil
+          variable_name = 'station_name_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/ 'max_name_len',     &
+                                                           'station_soil'/),   &
+                                      output_type = 'char' )
+!
+!--       z
+          variable_name = 'z_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       station_h for soil
+          variable_name = 'station_h_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       x soil
+          variable_name = 'x_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!-        y soil
+          variable_name = 'y_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       E-UTM soil
+          variable_name = 'E_UTM_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       N-UTM soil
+          variable_name = 'N_UTM_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       latitude soil
+          variable_name = 'lat_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       longitude soil
+          variable_name = 'lon_soil'
+          return_value = dom_def_var( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      dimension_names = (/'station_soil'/),    &
+                                      output_type = 'real32' )
+!
+!--       Set attributes for the coordinate variables. Note, not all coordinates
+!--       have the same number of attributes.
+!--       Units
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = char_unit,              &
+                                      value = 'seconds since ' // origin_date_time )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'z_soil',                &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_h_soil',        &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'x_soil',                &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'y_soil',                &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'E_UTM_soil',            &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'N_UTM_soil',            &
+                                      attribute_name = char_unit,              &
+                                      value = 'm' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lat_soil',              &
+                                      attribute_name = char_unit,              &
+                                      value = 'degrees_north' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lon_soil',              &
+                                      attribute_name = char_unit,              &
+                                      value = 'degrees_east' )
+!
+!--       Long name
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_name_soil',     &
+                                      attribute_name = char_long,              &
+                                      value = 'station name')
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = char_long,              &
+                                      value = 'time')
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'z_soil',                &
+                                      attribute_name = char_long,              &
+                                      value = 'height above origin' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_h_soil',        &
+                                      attribute_name = char_long,              &
+                                      value = 'surface altitude' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'x_soil',                &
+                                      attribute_name = char_long,              &
+                                      value = 'distance to origin in x-direction' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'y_soil',                &
+                                      attribute_name = char_long,              &
+                                      value = 'distance to origin in y-direction' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'E_UTM_soil',            &
+                                      attribute_name = char_long,              &
+                                      value = 'easting' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'N_UTM_soil',            &
+                                      attribute_name = char_long,              &
+                                      value = 'northing' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lat_soil',              &
+                                      attribute_name = char_long,              &
+                                      value = 'latitude' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lon_soil',              &
+                                      attribute_name = char_long,              &
+                                      value = 'longitude' )
+!
+!--       Standard name
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_name_soil',     &
+                                      attribute_name = char_standard,          &
+                                      value = 'platform_name')
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = char_standard,          &
+                                      value = 'time')
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'z_soil',                &
+                                      attribute_name = char_standard,          &
+                                      value = 'height_above_mean_sea_level' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_h_soil',        &
+                                      attribute_name = char_standard,          &
+                                      value = 'surface_altitude' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'E_UTM_soil',            &
+                                      attribute_name = char_standard,          &
+                                      value = 'projection_x_coordinate' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'N_UTM_soil',            &
+                                      attribute_name = char_standard,          &
+                                      value = 'projection_y_coordinate' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lat_soil',              &
+                                      attribute_name = char_standard,          &
+                                      value = 'latitude' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'lon_soil',              &
+                                      attribute_name = char_standard,          &
+                                      value = 'longitude' )
+!
+!--       Axis
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = 'axis',                 &
+                                      value = 'T')
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'z_soil',                &
+                                      attribute_name = 'axis',                 &
+                                      value = 'Z' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'x_soil',                &
+                                      attribute_name = 'axis',                 &
+                                      value = 'X' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'y_soil',                &
+                                      attribute_name = 'axis',                 &
+                                      value = 'Y' )
+!
+!--       Set further individual attributes for the coordinate variables.
+!--       For station name soil
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'station_name_soil',     &
+                                      attribute_name = 'cf_role',              &
+                                      value = 'timeseries_id' )
+!
+!--       For time soil
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = 'calendar',             &
+                                      value = 'proleptic_gregorian' )
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'time_soil',             &
+                                      attribute_name = 'bounds',               &
+                                      value = 'time_bounds' )
+!
+!--       For z soil
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = 'z_soil',                &
+                                      attribute_name = 'positive',             &
+                                      value = 'up' )
+       ENDIF
+!
+!--    Define variables that shall be sampled.
+       DO  n = 1, vmea(l)%nmeas
+          variable_name = TRIM( vmea(l)%var_atts(n)%name )
+!
+!--       In order to link the correct dimension names, atmosphere and soil
+!--       variables need to be distinguished.
+          IF ( vmea(l)%soil_sampling  .AND.                                    &
+               ANY( TRIM( vmea(l)%var_atts(n)%name) == soil_vars ) )  THEN
+
+             return_value = dom_def_var( vmea(l)%nc_filename,                  &
+                                         variable_name = variable_name,        &
+                                         dimension_names = (/'station_soil',   &
+                                                             'ntime_soil  '/), &
+                                         output_type = 'real32' )
+          ELSE
+
+             return_value = dom_def_var( vmea(l)%nc_filename,                  &
+                                         variable_name = variable_name,        &
+                                         dimension_names = (/'station',        &
+                                                             'ntime  '/),      &
+                                         output_type = 'real32' )
+          ENDIF
+!
+!--       Set variable attributes. Please note, for some variables not all
+!--       attributes are defined, e.g. standard_name for the horizontal wind
+!--       components.
+          CALL vm_set_attributes( vmea(l)%var_atts(n) )
+
+          IF ( vmea(l)%var_atts(n)%long_name /= 'none' )  THEN
+             return_value = dom_def_att( vmea(l)%nc_filename,                  &
+                                         variable_name = variable_name,        &
+                                         attribute_name = char_long,           &
+                                         value = TRIM( vmea(l)%var_atts(n)%long_name ) )
+          ENDIF
+          IF ( vmea(l)%var_atts(n)%standard_name /= 'none' )  THEN
+             return_value = dom_def_att( vmea(l)%nc_filename,                  &
+                                         variable_name = variable_name,        &
+                                         attribute_name = char_standard,       &
+                                         value = TRIM( vmea(l)%var_atts(n)%standard_name ) )
+          ENDIF
+          IF ( vmea(l)%var_atts(n)%units /= 'none' )  THEN
+             return_value = dom_def_att( vmea(l)%nc_filename,                  &
+                                         variable_name = variable_name,        &
+                                         attribute_name = char_unit,           &
+                                         value = TRIM( vmea(l)%var_atts(n)%units ) )
+          ENDIF
+
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      attribute_name = 'grid_mapping',         &
+                                      value = TRIM( vmea(l)%var_atts(n)%grid_mapping ) )
+
+          return_value = dom_def_att( vmea(l)%nc_filename,                     &
+                                      variable_name = variable_name,           &
+                                      attribute_name = 'coordinates',          &
+                                      value = TRIM( vmea(l)%var_atts(n)%coordinates ) )
+
+!           return_value = dom_def_att( vmea(l)%nc_filename,                     &
+!                                       variable_name = variable_name,           &
+!                                       attribute_name = char_fill,              &
+!                                       value = vmea(l)%var_atts(n)%fill_value )
+
+       ENDDO  ! loop over variables per site
+
+    ENDDO  ! loop over sites
+
+
+ END SUBROUTINE vm_init_output
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Parallel NetCDF output via data-output module.
+!------------------------------------------------------------------------------!
+ SUBROUTINE vm_data_output
+
+    CHARACTER(LEN=100) ::  variable_name !< name of output variable
+
+    INTEGER(iwp)       ::  l             !< loop index
+    INTEGER(iwp)       ::  n             !< loop index
+    INTEGER            ::  return_value  !< returned status value of called function
+
+    INTEGER(iwp)       ::  t_ind         !< time index
+
+    LOGICAL            ::  proceed_run   !< flag to indicate that the maximum number of
+                                         !< timesteps in the file will be exceeded
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE           ::  oro_rel                  !< relative altitude of model surface
+    REAL(wp), DIMENSION(:), POINTER               ::  output_values_1d_pointer !< pointer for 1d output array
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET   ::  output_values_1d_target  !< target for 1d output array
+    REAL(wp), DIMENSION(:,:), POINTER             ::  output_values_2d_pointer !< pointer for 2d output array
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET ::  output_values_2d_target  !< target for 2d output array
+
+!
+!-- At the first call of this routine write the spatial coordinates.
+    IF ( .NOT. initial_write_coordinates )  THEN
+!
+!--    Write spatial coordinates.
+       DO  l = 1, vmea_general%nvm
+!
+!--       Skip if no observations were taken.
+          IF ( vmea(l)%ns_tot == 0  .AND.  vmea(l)%ns_soil_tot == 0 )  CYCLE
+
+          ALLOCATE( output_values_1d_target(vmea(l)%start_coord_a:vmea(l)%end_coord_a) )
+!
+!--       Output of Easting coordinate. Before output, recalculate EUTM.
+          output_values_1d_target = init_model%origin_x                        &
                     + REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx &
                     * COS( init_model%rotation_angle * pi / 180.0_wp )         &
                     + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy &
                     * SIN( init_model%rotation_angle * pi / 180.0_wp )
-                 WRITE ( 27 )  'N_UTM                             '
-                 WRITE ( 27 )  init_model%origin_y                             &
+
+          output_values_1d_pointer => output_values_1d_target
+
+          return_value =                                                       &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'E_UTM',                                      &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_a  /) )
+!
+!--       Output of Northing coordinate. Before output, recalculate NUTM.
+          output_values_1d_target = init_model%origin_y                        &
                     - REAL( vmea(l)%i(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dx &
                     * SIN( init_model%rotation_angle * pi / 180.0_wp )         &
                     + REAL( vmea(l)%j(1:vmea(l)%ns) + 0.5_wp, KIND = wp ) * dy &
                     * COS( init_model%rotation_angle * pi / 180.0_wp )
-                 WRITE ( 27 )  'Z_AG                              '
-                 WRITE ( 27 )  vmea(l)%z_ag(1:vmea(l)%ns)
-                 WRITE ( 27 )  'soil sampling                     '
-                 WRITE ( 27 )  MERGE( 'yes                               ',    &
-                                      'no                                ',    &
-                                      vmea(l)%soil_sampling )
- 
-                 IF ( vmea(l)%soil_sampling )  THEN                 
-                    WRITE ( 27 )  'total number of soil points       '                               
-                    WRITE ( 27 )  vmea(l)%ns_soil_tot
-                    WRITE ( 27 )  'number of soil points             '
-                    WRITE ( 27 )  vmea(l)%ns_soil
-                    WRITE ( 27 )  'E_UTM soil                        '
-                    WRITE ( 27 )  init_model%origin_x                          &
-                       + REAL( vmea(l)%i_soil(1:vmea(l)%ns_soil) + 0.5_wp,     &
-                               KIND = wp ) * dx                                &
-                       * COS( init_model%rotation_angle * pi / 180.0_wp )      &
-                       + REAL( vmea(l)%j_soil(1:vmea(l)%ns_soil) + 0.5_wp,     &
-                               KIND = wp ) * dy                                &
-                       * SIN( init_model%rotation_angle * pi / 180.0_wp )
-                    WRITE ( 27 )  'N_UTM soil                        '
-                    WRITE ( 27 )  init_model%origin_y                          &
-                       - REAL( vmea(l)%i_soil(1:vmea(l)%ns_soil) + 0.5_wp,     &
-                               KIND = wp ) * dx                                &
-                       * SIN( init_model%rotation_angle * pi / 180.0_wp )      &
-                       + REAL( vmea(l)%j_soil(1:vmea(l)%ns_soil) + 0.5_wp,     &
-                               KIND = wp ) * dy                                &
-                       * COS( init_model%rotation_angle * pi / 180.0_wp )
-                    WRITE ( 27 )  'DEPTH                             '
-                    WRITE ( 27 )  vmea(l)%depth(1:vmea(l)%ns_soil)
-                 ENDIF
-              ENDDO
-
-           ENDIF
-        ENDDO
-        
+
+          output_values_1d_pointer => output_values_1d_target
+          return_value =                                                       &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'N_UTM',                                      &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_a  /) )
+!
+!--       Output of relative height coordinate.
+!--       Before this is output, first define the relative orographie height
+!--       and add this to z.
+          ALLOCATE( oro_rel(1:vmea(l)%ns) )
+          DO  n = 1, vmea(l)%ns
+             oro_rel(n) = zw(topo_top_ind(vmea(l)%j(n),vmea(l)%i(n),3))
+          ENDDO
+
+          output_values_1d_target = vmea(l)%zar(1:vmea(l)%ns) + oro_rel(:)
+          output_values_1d_pointer => output_values_1d_target
+          return_value =                                                       &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'z',                                          &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_a  /) )
+!
+!--       Write surface altitude for the station. Note, since z is already
+!--       a relative observation height, station_h must be zero, in order
+!--       to obtain the observation level.
+          output_values_1d_target = oro_rel(:)
+          output_values_1d_pointer => output_values_1d_target
+          return_value =                                                       &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'station_h',                                  &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_a/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_a  /) )
+
+          DEALLOCATE( oro_rel )
+          DEALLOCATE( output_values_1d_target )
+!
+!--       In case of sampled soil quantities, output also the respective 
+!--       coordinate arrays.
+          IF ( vmea(l)%soil_sampling )  THEN
+             ALLOCATE( output_values_1d_target(vmea(l)%start_coord_s:vmea(l)%end_coord_s) )
+!
+!--          Output of Easting coordinate. Before output, recalculate EUTM.
+             output_values_1d_target = init_model%origin_x                     &
+               + REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx &
+               * COS( init_model%rotation_angle * pi / 180.0_wp )              &
+               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy &
+               * SIN( init_model%rotation_angle * pi / 180.0_wp )
+             output_values_1d_pointer => output_values_1d_target
+             return_value =                                                    &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'E_UTM_soil',                                 &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_s  /) )
+!
+!--          Output of Northing coordinate. Before output, recalculate NUTM.
+             output_values_1d_target = init_model%origin_y                     &
+               - REAL( vmea(l)%i(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dx &
+               * SIN( init_model%rotation_angle * pi / 180.0_wp )              &
+               + REAL( vmea(l)%j(1:vmea(l)%ns_soil) + 0.5_wp, KIND = wp ) * dy &
+               * COS( init_model%rotation_angle * pi / 180.0_wp )
+
+             output_values_1d_pointer => output_values_1d_target
+             return_value =                                                    &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'N_UTM_soil',                                 &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_s  /) )
+!
+!--          Output of relative height coordinate.
+!--          Before this is output, first define the relative orographie height
+!--          and add this to z.
+             ALLOCATE( oro_rel(1:vmea(l)%ns_soil) )
+             DO  n = 1, vmea(l)%ns
+                oro_rel(n) = zw(topo_top_ind(vmea(l)%j_soil(n),vmea(l)%i_soil(n),3))
+             ENDDO
+
+             output_values_1d_target = vmea(l)%depth(1:vmea(l)%ns_soil) + oro_rel(:)
+             output_values_1d_pointer => output_values_1d_target
+             return_value =                                                    &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'z_soil',                                     &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_s  /) )
+!
+!--          Write surface altitude for the station. Note, since z is already
+!--          a relative observation height, station_h must be zero, in order
+!--          to obtain the observation level.
+             output_values_1d_target = oro_rel(:)
+             output_values_1d_pointer => output_values_1d_target
+             return_value =                                                    &
+                  dom_write_var( vmea(l)%nc_filename,                          &
+                                 'station_h_soil',                             &
+                                 values_realwp_1d = output_values_1d_pointer,  &
+                                 bounds_start = (/vmea(l)%start_coord_s/),     &
+                                 bounds_end   = (/vmea(l)%end_coord_s  /) )
+
+             DEALLOCATE( oro_rel )
+             DEALLOCATE( output_values_1d_target )
+!
+!--          Write the stations name
+             
+          ENDIF
+
+       ENDDO  ! loop over sites
+
+       initial_write_coordinates = .TRUE.
+    ENDIF
+!
+!-- Loop over all sites.
+    DO  l = 1, vmea_general%nvm
+!
+!--    Skip if no observations were taken.
+       IF ( vmea(l)%ns_tot == 0  .AND.  vmea(l)%ns_soil_tot == 0 )  CYCLE
+!
+!--    Determine time index in file.
+       t_ind = vmea(l)%file_time_index + 1
+!
+!--    Write output variables. Distinguish between atmosphere and soil variables.
+       DO  n = 1, vmea(l)%nmeas
+          IF ( vmea(l)%soil_sampling  .AND.                                    &
+            ANY( TRIM( vmea(l)%var_atts(n)%name) == soil_vars ) )  THEN
+!
+!--          Write time coordinate to file
+             variable_name = 'time_soil'
+             ALLOCATE( output_values_2d_target(t_ind:t_ind,vmea(l)%start_coord_s:vmea(l)%end_coord_s) )
+             output_values_2d_target(t_ind,:) = time_since_reference_point
+             output_values_2d_pointer => output_values_2d_target
+
+             return_value = dom_write_var( vmea(l)%nc_filename,                &
+                                           variable_name,                      &
+                                           values_realwp_2d = output_values_2d_pointer, &
+                                           bounds_start = (/vmea(l)%start_coord_s, t_ind/), &
+                                           bounds_end   = (/vmea(l)%end_coord_s, t_ind /) )
+
+             variable_name = TRIM( vmea(l)%var_atts(n)%name )
+             output_values_2d_target(t_ind,:) = vmea(l)%measured_vars_soil(:,n)
+             output_values_2d_pointer => output_values_2d_target
+             return_value =                                                    &
+                      dom_write_var( vmea(l)%nc_filename,                      &
+                                     variable_name,                            &
+                                     values_realwp_2d = output_values_2d_pointer, &
+                                     bounds_start = (/vmea(l)%start_coord_s, t_ind/), &
+                                     bounds_end   = (/vmea(l)%end_coord_s, t_ind  /) )
+             DEALLOCATE( output_values_2d_target )
+          ELSE
+!
+!--          Write time coordinate to file
+             variable_name = 'time'
+             ALLOCATE( output_values_2d_target(t_ind:t_ind,vmea(l)%start_coord_a:vmea(l)%end_coord_a) )
+             output_values_2d_target(t_ind,:) = time_since_reference_point
+             output_values_2d_pointer => output_values_2d_target
+
+             return_value = dom_write_var( vmea(l)%nc_filename,                &
+                                           variable_name,                      &
+                                           values_realwp_2d = output_values_2d_pointer, &
+                                           bounds_start = (/vmea(l)%start_coord_a, t_ind/), &
+                                           bounds_end   = (/vmea(l)%end_coord_a, t_ind/) )
+
+             variable_name = TRIM( vmea(l)%var_atts(n)%name )
+
+             output_values_2d_target(t_ind,:) = vmea(l)%measured_vars(:,n)
+             output_values_2d_pointer => output_values_2d_target
+             return_value =                                                    &
+                      dom_write_var( vmea(l)%nc_filename,                      &
+                                     variable_name,                            &
+                                     values_realwp_2d = output_values_2d_pointer, &
+                                     bounds_start = (/ vmea(l)%start_coord_a, t_ind /), &
+                                     bounds_end   = (/ vmea(l)%end_coord_a, t_ind /) )
+
+             DEALLOCATE( output_values_2d_target )
+          ENDIF
+       ENDDO
+!
+!--    Update number of written time indices
+       vmea(l)%file_time_index = t_ind
+
+    ENDDO  ! loop over sites
+!
+!-- Check if the time index exceeds its maximum values. This case, terminate the
+!-- run and force a restart. This is simply done by creating the file
+!-- DO_RESTART_NOW.
+    proceed_run = .TRUE.
+    IF ( ANY( vmea(:)%file_time_index >= ntimesteps - 1) )  proceed_run = .FALSE.
+
 #if defined( __parallel )
-        CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( MPI_IN_PLACE,                                          &
+                        proceed_run,                                           &
+                        1,                                                     &
+                        MPI_LOGICAL,                                           &
+                        MPI_LAND,                                              &
+                        MPI_COMM_WORLD,                                        &
+                        ierr )
 #endif
 !
-!--     After header information is written, set control flag to .FALSE.
-        init = .FALSE.
-!
-!--  Data output at each measurement timestep on each PE
-     ELSE
-        DO  i = 0, io_blocks-1
-
-           IF ( i == io_group )  THEN
-              WRITE( 27 )  'output time                       '
-              WRITE( 27 )  time_since_reference_point
-              DO  l = 1, vmea_general%nvm
-!
-!--              Skip binary writing if no observation points are defined on PE
-                 IF ( vmea(l)%ns < 1  .AND.  vmea(l)%ns_soil < 1)  CYCLE                 
-                 DO  n = 1, vmea(l)%nmeas
-                    WRITE( 27 )  vmea(l)%measured_vars_name(n)
-                    IF ( vmea(l)%soil_sampling  .AND.                           &
-                         ANY( TRIM( vmea(l)%measured_vars_name(n))  ==          &
-                              soil_vars ) )  THEN                   
-                       WRITE( 27 )  vmea(l)%measured_vars_soil(:,n)
-                    ELSE
-                       WRITE( 27 )  vmea(l)%measured_vars(:,n)
-                    ENDIF
-                 ENDDO
-           
-              ENDDO
-           ENDIF
-        ENDDO
-#if defined( __parallel )
-        CALL MPI_BARRIER( comm2d, ierr )
-#endif
-     ENDIF
-  
-  END SUBROUTINE vm_data_output  
-  
-  
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Write end-of-file statement as last action.
-!------------------------------------------------------------------------------!
-  SUBROUTINE vm_last_actions
-    
-     USE pegrid
-    
-     IMPLICIT NONE
-         
-     INTEGER(iwp) ::  i         !< running index over IO blocks    
- 
-     DO  i = 0, io_blocks-1
-        IF ( i == io_group )  THEN
-           WRITE( 27 )  'EOF                               '
-        ENDIF
-     ENDDO
-#if defined( __parallel )
-        CALL MPI_BARRIER( comm2d, ierr )
-#endif
-!
-!--  Close binary file
-     CALL close_file( 27 )
-  
-  END SUBROUTINE vm_last_actions 
-  
+!-- Create file DO_RESTART_NOW to force a restart. This file is only created
+!-- by rank 0 of the root domain.
+    IF ( myid == 0  .AND.  .NOT. child_domain  .AND.  .NOT. proceed_run )  THEN
+       OPEN( 999, FILE='DO_RESTART_NOW' )
+       CLOSE( 999 )
+
+       message_string = 'Run will be terminated because virtual ' //           &
+                        'measurement times index exceeds its maximum value ' //&
+                        'in the output files. A restart run is forced.' 
+       CALL message( 'vm_data_output', 'PA0707', 0, 0, 0, 6, 0 )
+    ENDIF
+
+  END SUBROUTINE vm_data_output
+
 !------------------------------------------------------------------------------!
 ! Description:
